<copyright> It Tool class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: Tool.t,v 1.4 1998/03/09 21:26:43 tiggr Exp $</id>
    </copyright>

implementation class
Tool: it

<doc> Designated allocator.  </doc>
instance (id)
  withCell ButtonCell c
{
  = [[self alloc] initWithCell c];
}

<doc> Return the names of the normal and alternate images to be displayed
    for this tool in the tool kit.  </doc>
deferred (String, String) (normal, alternate)
  cell_images;

end;

implementation instance
Tool

<doc> Designated initializer.  </doc>
protected id
  initWithCell ButtonCell c
{
  String n, a;

  (n, a) = [isa cell_images];
  [c set_image [Image named n]];
  [c set_alternate_image [Image named a]];

  = [super init];
}

<doc><h4>Tool activity exposure</h4></doc>

<doc> This tool is involved in modifying the document {d} (for which it is
    the {active_tool}), and should display what it is doing.  The focus
    has been locked on the document {d}.  </doc>
void
  drawActivity (float, float, float, float) (x, y, w, h)
	    in Document d
{
}

<doc><h4>Tool event handling</h4>

    The events offered to tools have locations in the coordinate system of
    the document they relate to.  </doc>

<doc> Being the active tool, handle a mouse down event {e} in the document
    {d}.  Return {TRUE} if subsequent events are of interest to this tool.
    If {FALSE} is returned, no {mouseDragged in} or {mouseUp in} will be
    sent.  The default implementation simply returns {FALSE}.  </doc>
boolean
  mouseDown MouseEvent e
	 in Document d
{
}

void
  mouseDragged MouseEvent e
	    in Document d
{
}

void
  mouseUp MouseEvent e
       in Document d
{
}

end;
