<copyright> It Rectangle and rectangle classes.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: Rectangle.t,v 1.1 1998/04/19 15:00:20 tiggr Exp $</id>
    </copyright>

/******************** rectangle ********************/

implementation class
rectangle: PlugIt

end;

implementation instance
rectangle

<doc> Designated initializer.  </doc>
id
  init
{
  = [super init];
  [[ToolKit shared] newTool [RectangleTool self]];
}

String
  plugItName
{
  = "rectangle";
}

int
  plugItVersion
{
  = 0;
}

end;

/******************** Rectangle ********************/

implementation class
Rectangle: SimpleObject

end;

implementation instance
Rectangle

<doc> Add the {ellipse} plugit to {display}.  </doc>
void
  collectPlugIts (MutableKeyed, MutableKeyed) (display, edit)
{
  [display add [rectangle shared]];
}

void
  drawSelf (float, float, float, float) (x, y, w, h)
	in Document doc
{
  Display d = [doc currentDisplay];
  [d setColor [Color black]];
  [d newpath];
  [d moveto (blx, bly)];
  [d lineto (brx, bry)];
  [d lineto (trx, try)];
  [d lineto (tlx, tly)];
  // [d closepath];
  // Sun Apr 19 00:39:48 1998, tiggr@gerbil.org
  [d lineto (blx, bly)];
  [d stroke];
}

end;
