<copyright> It Constants.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: Constants.t,v 1.6 1998/04/15 22:45:49 tiggr Exp $</id>
    </copyright>

implementation class
Constants: tag.Constants
{
  <doc> The notifications.  </doc>
  static UniqueString notification_document_new;
  static UniqueString notification_document_open;

  <doc> Layer positioning.  </doc>
  const LAYER_POSITION_BOTTOM = -1;
  const LAYER_POSITION_TOP = 0;

  <doc> Points in shapes.  </doc>
  const SHAPE_POINT_LAST = -1;
  const SHAPE_POINT_FIRST = 0;

  <doc> Various priorities of a hit on a object.

      Base priority is nothing special, e.g., a hit on an unselected line
      segment.  </doc>
  const HIT_PRIO_BASE = 0;

  <doc> Hit on a selected object.  </doc>
  const HIT_PRIO_SELECTED = 1;

  <doc> Hit on a detail of an object, e.g., a point of a shape.  </doc>
  const HIT_PRIO_DETAIL = 2;

  <doc> Hit on some part of the decoration of an object which is not
      normally visible, e.g., one of the control points of a curve.
      </doc>
  const HIT_PRIO_DECORATION = 3;

  <doc> Constants for use by {Point} and {Shape} when determining how to
      respond to a mouse down with the selection tool.  </doc>
  const SHAPE_POINT_TO = -1;
  const SHAPE_POINT_POSITION = 0;
  const SHAPE_POINT_FROM = 1;

  <doc> The dimensions of an inspector.  </doc>
  const INSPECTOR_WIDTH = 200.0;
  const INSPECTOR_HEIGHT = 200.0;
}

end;

implementation instance Constants end;
