<copyright> It Inspector class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: Inspector.t,v 1.1 1998/04/15 22:45:54 tiggr Exp $</id>
    </copyright>

implementation class
Inspector: it
{
  <doc> The shared inspector of this particular inspector (sub-) class.
      </doc>
  instance (id) shared;
}

<doc> Return the shared instance of this (sub-) class.  </doc>
instance (id)
  shared
{
  if (!shared)
    shared = [self new];
  = shared;
}

end;

implementation instance
Inspector
{
  <doc> The view of this inspector.  </doc>
  public View view;
}

<doc> Designated initializer.  Sets the {view} to a plain view, if that
    has not already been set.  </doc>
id
  init
{
  if (!view)
    view = [[View alloc]
	     initFrame (0.0, 0.0, INSPECTOR_WIDTH, INSPECTOR_HEIGHT)];
  = [super init];
}

end;

/******************** PlainInspector ********************/

implementation class
PlainInspector: Inspector

end;

implementation instance
PlainInspector
{
  // Not really used as such, but it'll do.
  // Thu Apr 16 00:00:07 1998, tiggr@gerbil.org
  <doc> Our view is a button.  </doc>
  redeclare Button view;
}

<doc> Designated initializer.  </doc>
id
  init
{
  view = [[Button alloc]
	   initFrame (0.0, 0.0, INSPECTOR_WIDTH, INSPECTOR_HEIGHT)];
  = [super init];
}

<doc> Modify the title of the {view}.  </doc>
id (self)
  withTitle String title
{
  [view setTitle title];
}

end;
