<copyright> It Lex class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: Lex.t,v 1.1 1998/04/10 20:49:41 tiggr Exp $</id>
    </copyright>

implementation class
Lex: XL, Lexer, ParseDefines

end;

implementation instance
Lex
{
  public mutable Parser parser;
}

String
  filename
{
}

int
  current_line
{
}

int
  nextToken
{
  int t = [super (XL) nextToken];
  if (t == XLT_SYMBOL)
    {
      byte b = buffer[0];
      if (b == 'c' && [buffer equal "check-plugit"])
	return token = CHECK_PLUGIT;
      if (b == 'd' && [buffer equal "display-plugits"])
	return token = DISPLAY_PLUGITS;
      if (b == 'e' && [buffer equal "edit-plugits"])
	return token = EDIT_PLUGITS;
      if (b == 'l' && [buffer equal "layers"])
	return token = LAYERS;
    }

  if (t == XLT_EOF)
    {
      // GPS parsers still expect 0 for EOF...
      // Fri Apr 10 22:29:54 1998, tiggr@gerbil.org
      return 0;
    }

  return t;
}

<doc> Return the {buffer} if the current token is a symbol or a number.
    </doc>
Any
  semantics
{
  if (token >= XLT_DOUBLE && token <= XLT_SYMBOL)
    = Any (buffer);
}

end;
